DWORD main(int argc, char *argv[])
{
    HANDLE  hPipe;
    LPVOID  lpvMessage;
    CHAR    chBuf[512];
    BOOL    fSuccess;
    DWORD   cbRead,
            cbWritten,
            dwMode;
    LPTSTR lpszPipename = "\\\\.\\pipe\\mynamedpipe";

    while(1)
    {
        hPipe = CreateFile(lpszPipename, GENERIC_READ | GENERIC_WRITE,
               0, NULL, OPEN_EXISTING, 0, NULL);
        if(hPipe != INVALID_HANDLE_VALUE)
            break;
        if(GetLastError() != ERROR_PIPE_BUSY)
            MyErrExit("Could not open pipe");
        if(!WaitNamedPipe(lpszPipename, 20000))
            MyErrExit("Could not open pipe");
    }
    dwMode = PIPE_READMODE_MESSAGE;
    fSuccess = SetNamedPipeHandleState(hPipe, &dwMode, NULL, NULL);
    if(!fSuccess)
        MyErrExit("SetNamedPipeHandleState");
    lpvMessage = (argc > 1) ? argv[1] : "default message";
    fSuccess = WriteFile(hPipe, lpvMessage, strlen(lpvMessage) + 1,
                                         &cbWritten, NULL);
    if(!fSuccess)
        MyErrExit("WriteFile");
    do{
        fSuccess = ReadFile(hPipe, chBuf, 512, &cbRead, NULL);
        if(!fSuccess && GetLastError() != ERROR_MORE_DATA)
            break;
        if(!WriteFile(GetStdHandle(STD_OUTPUT_HANDLE),
                                 chBuf, cbRead, &cbWritten, NULL))
            break;
    }while(!fSuccess);
    CloseHandle(hPipe);
    return 0;
}
