
typedef struct{
    int iCounter;
    HANDLE hReaderEvent;
    HANDLE hMutex;
    HANDLE hWriterMutex;
} win32_rwlock_t;


int win32_rwlock_init(win32_rwlock_t* lock){
    lock->hReaderEvent=CreateEvent(NULL,TRUE,FALSE,NULL);
    lock->hMutex = CreateEvent(NULL,FALSE,TRUE,NULL);
    lock->hWriterMutex = CreateMutex(NULL,FALSE,NULL);
    iCounter = 0;
    return 0;
}

int win32_rw_lock_destroy(win32_wrlock_t* lock){
    CloseHandle(lock->hReaderEvent);
    CloseHandle(lock->hMutex);
    CloseHandle(lock->hWriterMutex);
    return 0;
}

int pthread_rwlock_wrlock(win32_rwlock_t* lock){
    WaitForSingleObject(lock->hWriterMutex,INFINITE);
    WaitForSingleObject(lock->hMutex, INFINITE);
    return 0;
}

int win32_rwlock_rdlock(win32_rwlock_t* lock){
    if(InterlockedIncrement(&lock->iCounter) == 1){
        WaitForSingleObject(lock->hMutex, INFINITE);
        SetEvent(lock->hReaderEvent);
    };
    WaitForSingleObject(lock->hReaderEvent,INFINITE);
    return 0;
};

int pthread_rwlock_unlock(win32_rwlock_t* lock){
    LONG c=InterlockedDecrement(&lock->iCounter);
    if(c<0){
        InterlockedIncrement(&lock->iCounter);
        SetEvent(lock->hMutex);
        ReleaseMutex(lock->hWriterMutex);
    }
    else{
        if (c == 0){
            ResetEvent(lock->hReaderEvent);
            SetEvent(lock->hMutex);
        }
    }
    return 0;
}
