/* POSIX_barrier.h  - plik naglowkowy */
#include <pthread.h>

typedef struct barrier_struct {
  pthread_cond_t     cond; /* zm. war. dla oczekujacych przed bariera */
  pthread_mutex_t    lock; /* mutex dla oczekujacych przed bariera */
  int                maxcnt;    /* wytrzymalosc bariery */
  int                cnt;     /* liczba czekajacych watkow */
  int                phase;   /* flaga zeby odseparowac dwie bariery */
} * barrier_t;

#ifdef __cplusplus
extern "C" {
#endif

barrier_t   barrier_init(int max);
void        barrier_wait(barrier_t barrier);
void        barrier_destroy(barrier_t barrier);
#ifdef __cplusplus
}
#endif