class Bufor {
   private int contents;
   private boolean available = false;
   public synchronized int get() {
      // jeli obiekt nie gotowy czekamy
      while (available == false) {
         try { wait(); } // zawieszamy wtek
         catch (InterruptedException e) {}
      }
      available = false;
      notifyAll();  // umoliwia powtrne wykonanie wtku
      return contents;
   }
   public synchronized void put(int value) {
      // jeli obiekt nie zosta pobrany czekamy
      while (available == true) {
         try { wait(); }
         catch (InterruptedException e) {}
      }
      contents = value;
      available = true;
      notifyAll();
   }
}
class Producer extends Thread {
   private Bufor buf;
   private int number;
   public Producer(Bufor c, int number) {
      buf = c;
      this.number = number;
   }
   public void run() {
      for (int i = 0; i < 10; i++) {
         buf.put(i);
         System.out.println("Producer #"+this.number+" put: "+i);
         try {
            sleep((int)(Math.random() * 100));
         } catch (InterruptedException e) {}
      }
   }
}
class Consumer extends Thread {
   private Bufor buf;
   private int number;
   public Consumer(Bufor c, int number) {
      buf = c;
      this.number = number;
   }
   public void run() {
      int value = 0;
      for (int i = 0; i < 10; i++) {
         value = buf.get();
         System.out.println("Consumer #"+this.number+" got: "+value);
      }
   }
}
public class ProducerConsumerTest {
   public static void main(String[] args) {
      Bufor c = new Bufor();
      Producer p1 = new Producer(c, 1);
      Consumer c1 = new Consumer(c, 1);
      p1.start(); c1.start();
   }
}
