/* sum_kolor.c
 * obliczanie maksymalnej wartosci funkcji w~pokolorowanym komunikatorze
 * funkcja: cos(100.*(procId+10))
*/
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "mpi.h"

int main(int argc, char **argv) {
    int procId, procId_nowy, kolor;
    MPI_Comm nowycomm;
    float kat, fun, maks;
    char *nazwa[2];
    nazwa[0] = "biay"; nazwa[1] = "czarny";

    MPI_Init(&argc, &argv);
    MPI_Comm_rank(MPI_COMM_WORLD,&procId);

  // Utworzenie dwoch komunikatorow (zapamietywane przez zmienna "nowycom"):
  // czarny (dla zadan z parzystym Id),
  // bialy  (dla zadan z nieparzystym Id)

    kolor = procId % 2;
    MPI_Comm_split(MPI_COMM_WORLD, kolor, procId, &nowycomm);

  // Obliczenie funkcji i wyswietlenie wyniku

    kat = 100. * (procId + 10);
    fun = cos(kat);
    printf("Kolor: %6s, Id procesu: %d, argument: %5.0f,\
                                  wartosc funkcji: %8.7f\n",
                                        nazwa[kolor], procId, kat, fun);

  // Wyznaczenie maksymalnej wartosci funkcji dla kazdego komunikatora

    MPI_Reduce(&fun, &maks, 1, MPI_FLOAT, MPI_MAX, 0, nowycomm);
    MPI_Comm_rank (nowycomm, &procId_nowy);

  // Wyswietlenie maksymalnych wartosci
    if (procId_nowy == 0)
        printf("Komunikator (kolor): %6s, maksimum: %8.7f\n",
	                                           nazwa[kolor], maks);

    MPI_Finalize();
    return 0;
}

