#include <stdlib.h>

void _MyIterationInitialize( float***, float**, float**, int );

int	MyIteration( float *pSnapshot, int length, int iStart, int iEnd ) {
	static float **pA = NULL,
	              *pb = NULL,
	              *px = NULL;
	int i, row;

	if( !pA )
		_MyIterationInitialize( &pA, &pb, &px, length );
	if( iStart < 0 || iEnd >= length || iEnd < iStart )
		return( !0 );
	for( row = iStart; row <= iEnd; row++ ) {
		px[ row ] = 0;
		for( i = 0; i < length; i++ )
			px[ row ] += pA[ row ][ i ] * pSnapshot[ i ];
		pSnapshot[ row ] -= ( px[ row ] - pb[ row ] ) / pA[ row ][ row ];
	}
	return( 0 );
}
