#define _REENTRANT
#include <pthread.h>
#include <thread.h>
#include <stdio.h>
#include "MyIterationProg.h"

#define DIM 5

float Snapshot[ DIM ];
pthread_mutex_t Mutex = PTHREAD_MUTEX_INITIALIZER;
pthread_mutex_t BarrierMutex = PTHREAD_MUTEX_INITIALIZER;
pthread_cond_t  BarrierCond  = PTHREAD_COND_INITIALIZER;
int             StoppedCount = 0;

struct ThreadArg {
	char  *pHostName;
	int    iStart, iEnd;
};

void *SideThread( void *pArg );

int main( int argc, char *argv[] ) {
	int i;
	pthread_t sideThread1,
              sideThread2;
	struct ThreadArg thrArg1,
                     thrArg2;

	for( i = 0; i < DIM; i++ )
		Snapshot[ i ] = i + 1;
    if( argc < 3 ) {
        printf( "Usage: %s remote_host1 remote_host2\n", argv[ 0 ] );
        return( 1 );
    }
	thrArg1.pHostName = argv[ 1 ];
	thrArg1.iStart    = 0;
	thrArg1.iEnd      = 1;
	pthread_create( &sideThread1, NULL, SideThread, &thrArg1 );
	thrArg2.pHostName = argv[ 2 ];
	thrArg2.iStart    = 2;
	thrArg2.iEnd      = DIM - 1;
	pthread_create( &sideThread2, NULL, SideThread, &thrArg2 );
	pthread_join( sideThread1, NULL );
	pthread_join( sideThread2, NULL );
	return( 0 );
}

void *SideThread( void *pArg ) {
	int i;
	struct ThreadArg *pThreadArg =
                                ( struct ThreadArg * )pArg;
	float x[ DIM ];
	MyIterationParameters parameters = { DIM, NULL, 0, 0, 0 };
	MyIterationParameters *pResult;
	CLIENT *pClnt;

	pClnt = clnt_create( pThreadArg->pHostName, MY_ITERATION_PROG,
						 MY_ITERATION_VER, "tcp" );
    if( !pClnt ) {
        clnt_pcreateerror( pThreadArg->pHostName );
        return( NULL );
    }
	parameters.snapshot.snapshot_val = x;
	parameters.iStart = pThreadArg->iStart;
	parameters.iEnd   = pThreadArg->iEnd;
	while( !0 ) {
		pthread_mutex_lock( &Mutex );
		memcpy( x, Snapshot, sizeof( x ) );
		pthread_mutex_unlock( &Mutex );
		pResult = my_iteration_proc_1( &parameters, pClnt );
		pthread_mutex_lock( &Mutex );
		printf( "Thread %d: ", pthread_self() );
		if( !pResult->snapshot.snapshot_val ) {
			pthread_mutex_unlock( &Mutex );
			continue;
		}
    	for( i = 0; i < DIM; i++ ) {
        	printf( " %f", pResult->snapshot.snapshot_val[ i ] );
			if( i >= pThreadArg->iStart && i <= pThreadArg->iEnd )
				Snapshot[ i ] = pResult->snapshot.snapshot_val[ i ];
		}
		printf( "\n" );
		pthread_mutex_unlock( &Mutex );
    	xdr_free( xdr_MyIterationParameters, ( char * )pResult );
		pthread_mutex_lock( &BarrierMutex );
		StoppedCount++;
		if( StoppedCount == 2 ) {
			StoppedCount = 0;
			pthread_cond_broadcast( &BarrierCond );
		}
		else
			pthread_cond_wait( &BarrierCond, &BarrierMutex );
		pthread_mutex_unlock( &BarrierMutex );
	}
}
