import java.rmi.*;
import java.rmi.server.*;
import java.net.*;

public class MyIterationImplementation
		extends UnicastRemoteObject implements MyIterationInterface {
	public MyIterationImplementation() throws RemoteException
	{ super(); }
	public native int myIterationWrapper( float snapshot[],
										  int   iStart,
										  int   iEnd );
	public MyIterationParameters MyIteration(
					MyIterationParameters parameters ) throws RemoteException {
		parameters.errorCode =  myIterationWrapper(
							parameters.x, parameters.iStart, parameters.iEnd );
		return parameters;
	}
	static {
		System.loadLibrary( "myIterationWrapper" );
	}
	public static void main( String args[] ) throws Exception {
		String hostName = InetAddress.getLocalHost().getHostName();
		if( System.getSecurityManager() == null )
				System.setSecurityManager( new RMISecurityManager() );
		Naming.rebind( "//" + hostName + "/MyIteration",
								   new MyIterationImplementation() );
	}
}
